Name:           ros-kilted-ros2-controllers
Version:        5.2.0
Release:        1%{?dist}
Summary:        ROS package ros2-controllers

License:        Apache License 2.0
URL:            https://control.ros.org

Source0:        https://github.com/ros2-gbp/ros2_controllers-release/archive/release/kilted/ros2_controllers/5.2.0-1.tar.gz#/ros-kilted-ros2-controllers-5.2.0-source0.tar.gz


BuildArch: noarch

# common BRs
BuildRequires: patchelf
BuildRequires: coreutils
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  ros-kilted-ament-cmake
BuildRequires:  ros-kilted-ament-package

Requires:       ros-kilted-ackermann-steering-controller
Requires:       ros-kilted-admittance-controller
Requires:       ros-kilted-bicycle-steering-controller
Requires:       ros-kilted-diff-drive-controller
Requires:       ros-kilted-effort-controllers
Requires:       ros-kilted-force-torque-sensor-broadcaster
Requires:       ros-kilted-forward-command-controller
Requires:       ros-kilted-gpio-controllers
Requires:       ros-kilted-gps-sensor-broadcaster
Requires:       ros-kilted-imu-sensor-broadcaster
Requires:       ros-kilted-joint-state-broadcaster
Requires:       ros-kilted-joint-trajectory-controller
Requires:       ros-kilted-mecanum-drive-controller
Requires:       ros-kilted-parallel-gripper-controller
Requires:       ros-kilted-pid-controller
Requires:       ros-kilted-pose-broadcaster
Requires:       ros-kilted-position-controllers
Requires:       ros-kilted-range-sensor-broadcaster
Requires:       ros-kilted-steering-controllers-library
Requires:       ros-kilted-tricycle-controller
Requires:       ros-kilted-tricycle-steering-controller
Requires:       ros-kilted-velocity-controllers

Requires:       ros-kilted-ament-cmake
Requires:       ros-kilted-ament-package
Requires:       ros-kilted-ackermann-steering-controller
Requires:       ros-kilted-admittance-controller
Requires:       ros-kilted-bicycle-steering-controller
Requires:       ros-kilted-diff-drive-controller
Requires:       ros-kilted-effort-controllers
Requires:       ros-kilted-force-torque-sensor-broadcaster
Requires:       ros-kilted-forward-command-controller
Requires:       ros-kilted-gpio-controllers
Requires:       ros-kilted-gps-sensor-broadcaster
Requires:       ros-kilted-imu-sensor-broadcaster
Requires:       ros-kilted-joint-state-broadcaster
Requires:       ros-kilted-joint-trajectory-controller
Requires:       ros-kilted-mecanum-drive-controller
Requires:       ros-kilted-parallel-gripper-controller
Requires:       ros-kilted-pid-controller
Requires:       ros-kilted-pose-broadcaster
Requires:       ros-kilted-position-controllers
Requires:       ros-kilted-range-sensor-broadcaster
Requires:       ros-kilted-steering-controllers-library
Requires:       ros-kilted-tricycle-controller
Requires:       ros-kilted-tricycle-steering-controller
Requires:       ros-kilted-velocity-controllers

Provides:  ros-kilted-ros2-controllers = 5.2.0-1
Obsoletes: ros-kilted-ros2-controllers < 5.2.0-1


%description
Metapackage for ros2_controllers related packages




%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SOURCE=1; export GZ_BUILD_FROM_SOURCE
export GZ_VERSION=harmonic;

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros-kilted/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR

colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  -Dgz_add_get_install_prefix_impl_OVERRIDE_INSTALL_PREFIX_ENV_VARIABLE="%{_libdir}/ros-kilted/opt/" \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros-kilted/ \
  --packages-select ros2_controllers



# remove wrong buildroot prefixes
# find %{buildroot}/%{_libdir}/ros-kilted/ -type f -exec sed -i "s:%{buildroot}::g" {} \;
# we should exclude binaries from that as it might corrupt shared libraries
find %{buildroot}/%{_libdir}/ros-kilted/ -type f ! -name '*.so*' -exec sh -c 'file "{}" | grep -q text && sed -i "s:%{buildroot}::g" "{}"' \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/include/ros2_controllers ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/include/ros2_controllers
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/include/* %{buildroot}/%{_libdir}/ros-kilted/include/ros2_controllers/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/include
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/extra_cmake
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/extra_cmake/* %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/extra_cmake/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/extra_cmake
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/share/ros2_controllers ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/share/ros2_controllers
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/share/* %{buildroot}/%{_libdir}/ros-kilted/share/ros2_controllers/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/share
# fi

# # Move other opt path if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/* %{buildroot}/%{_libdir}/ros-kilted/
#     rm  -rd %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers
# fi

rm -rf %{buildroot}/%{_libdir}/ros-kilted/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# vendor pkg removal
rm -rf %{buildroot}/%{_libdir}/ros-kilted/opt/share/ros2_controllers/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros-kilted/{share,bin,etc,tools,lib64/python*,lib/python*/site-packages,lib/python*/dist-packages} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros-kilted/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/ros2_controllers \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list

find %{buildroot}/%{_libdir}/ros-kilted/{lib*/pkgconfig,include/,cmake/,ros2_controllers/include/,share/ros2_controllers/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/ros2_controllers/{lib*/pkgconfig,include/,cmake/,extra_cmake/,ros2_controllers/include/,share/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/extra_cmake \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/ros2_controllers/{lib*/pkgconfig,include/,cmake/,ros2_controllers/include/,/share/cmake,/extra_cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/ament_index/resource_index \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/colcon-core/packages/ \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/ros2_controllers/{hook,environment,cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;
find %{buildroot}/%{_libdir}/ros-kilted/ -name "*.so*" -type f -exec patchelf  --shrink-rpath --allowed-rpath-prefixes %{_libdir} {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/TarikViehmann/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done

sort files.list | uniq > files.list.tmp && mv files.list.tmp files.list

%files -f files.list


%changelog
* Wed Jun 25 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - kilted.5.2.0-1
- Update to latest release
* Sun Jun 22 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - kilted.5.1.0-1
- Update to latest release
